unit Graph2d;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type

  TPixel         = array [1..2] of Integer;
  TPoint         = array [1..3] of Double;
  TArrayOfPoints = array [0..800] of TPoint;
  TMatrix   = array [1..3,1..3] of Double;
  TVector   = array [1..3]      of Double;

  TDraw2D = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
   
  private
    { Private declarations }

      PointOnScanRow: PByteArray;

  public
    { Public declarations }

    {Velikost uivatelskch jednotek ve svtovch souadnicch}
    Unit_X,Unit_Y         :Double;
    {Svtov souadnice uivatelskho potku}
    O                     :TPoint;
    {Body}
    A,B,C,D,Ac,Bc,Cc,Dc   :TPoint;
    {promnn + uivatelsk rozmry kreslc plochy}
    x1,x2,y1,y2,x,y,hx,hy,
    {parametr a jeho interval}
    t,t1,t2,ht,
    c1,c2,hC,
    {argument a jeho interval - pro polrn souadnice}
    fi,fi1,fi2,hfi        :Double;
    {Barevn sloky}
    Red,Green,Blue        :Byte;
    {Polygony pro kivky}
    P,Q                   :TArrayOfPoints; 
    {***** svtov souadnice *****}

    {Nastaven velikosti obrazu a hloubky pixelu}
    Procedure InitImage(Width,Height:Integer);
    {nastaven barvy z batevnch sloek}
    Procedure ClearDigitalImage(Red,Green,Blue:byte);
    {Nastaven uivatelskch rozmr kreslc plochy}
    procedure Scale(x1,x2,y1,y2:Double);
    {Pepoet prvn uivatelsk souadnice na svtovou}
    function  XCoor(x:Double):integer;
    {Pepoet druh uivatelsk souadnice na svtovou}
    function  YCoor(y:Double):integer;
    {Pepoet prvn svtov souadnice na uivatelskou}
    function  InvXCoor(x:Integer):Double;
    {Pepoet druh svtov souadnice na uivatelskou}
    function  InvYCoor(y:Integer):Double;
    {Sestroj bod ve svtovch souadnicch zadanou barvou}
    procedure PutPixel(X:TPixel;Red,Green,Blue:byte);
    {Zjist barvu bodu zadanho ve svtovch souadnicch}
    Procedure GetPixel(X:TPixel;var Red,Green,Blue:byte);
    {Sestroj seku ve svtovch souadnicch zadanou barvou}
    procedure PixelLine(X,Y:TPixel;Red,Green,Blue:byte);
    {Sestroj seku interpolovanou barvou ve svtovch souadnicch}
    procedure PixelInterpolLine(X,Y:TPixel;RedX,GreenX,BlueX,
                                   RedY,GreenY,BlueY:byte);

    {***** uivatelsk souadnice - ScanLine*****}

    {Sestroj bod v uivatelskch souadnicch zadanou barvou}
    procedure PutPoint(X:TPoint;Red,Green,Blue:byte);
    {Zjist barvu bodu zadanho v uivatelskch souadnicch}
    procedure GetPoint(X:TPoint;var Red,Green,Blue:byte);
    {Sestroj kek na uivatelskch souadnicch zadanou barvou}
    Procedure Cross(X:TPoint;Size,Red,Green,Blue:byte);
    {Sestroj seku v uivatelskch souadnicch zadanou barvou}
    procedure Line(X,Y:TPoint;Red,Green,Blue:byte);
   {Sestroj seku interpolovanou barevou v uivatelskch souadnicch}
    procedure PointInterpolLine(X,Y:TPoint;RedX,GreenX,BlueX,
                                             RedY,GreenY,BlueY:byte);
   {Sestroj rovnobku s osou x zadanou barvou}
    Procedure XAxis(x1,x2,y:Double;Red,Green,Blue:byte);
    {Sestroj rovnobku s osou y zadanou barvou}
    Procedure YAxis(y1,y2,x:Double;Red,Green,Blue:byte);
    {Sestroj cejchovanou rovnobku s osou x zadanou barvou}
    Procedure GaugedXAxis(x1,x2,y:Double;Red,Green,Blue:byte);
    {Sestroj cejchovanou rovnobku s osou y zadanou barvou}
    procedure GaugedYAxis(y1,y2,x:Double;Red,Green,Blue:byte);
    {Sestroj polygon prochzenc prvnmi n body zadanho pole zadanou barvou}
    procedure PolyLine(X:TArrayOfPoints;n:Word;Red,Green,Blue:byte);
    {Sestroj trojhelnk zadanou barvou}
    procedure Triangle(A,B,C:TPoint;Red,Green,Blue:byte);
    {Sestroj tyhelnk zadanou barvou}
    procedure Quadrangle(A,B,C,D:TPoint;Red,Green,Blue:byte);

    {***** uivatelsk souadnice - Canvas*****}

    Procedure ClearImage(Red,Green,Blue:byte);
    {Sestroj seku v uivatelskch souadnicch zadanou barvou}
    procedure cvLine(X,Y:TPoint;Red,Green,Blue:byte);
    {Sestroj polygon prochzenc prvnmi n body zadanho pole zadanou barvou}
    procedure cvPolyLine(X:TArrayOfPoints;n:Word;Red,Green,Blue:byte);
     {Sestroj trojhelnk zadanou barvou}
    procedure cvTriangle(A,B,C:TPoint;Red,Green,Blue:byte);
     {Sestroj tyhelnk zadanou barvou}
    procedure cvQuadrangle(A,B,C,D:TPoint;Red,Green,Blue:byte);
    {Sestroj krunici zadanou barvou}
    procedure cvCircle(S:TPoint;r:Double;Red,Green,Blue:byte);

   {**** nastaven matic zakladnich tansformac *****}

   {transformace bodu X matic Z do bodu X'}
    procedure TransOfPoint(X:TPoint;Z:TMatrix;var Xc:TPoint);
   {transformace trojhelnka ABC matic Z do trojhelnka A'B'C'}
    Procedure TransOfTriangle(A,B,C:TPoint;Z:TMatrix;var Ac,Bc,Cc:TPoint);
   {posunut o vektor v}
    Procedure Transl   (V:TVector;var T:TMatrix);
   {otoen o hel alfa kolem potku}
    Procedure Rot     (Alfa:Double;var R:TMatrix);
   {stedov soumrnost se stedem v potku}
    Procedure OrigSym (var S:TMatrix);
   {osov soumrnost podle x}
    Procedure AxisSymX(var O:TMatrix);
   {osov soumrnost podle y}
    Procedure AxisSymY(var O:TMatrix);
   {osov afinita podle x}
    Procedure AfX     (P:TPoint;var A:TMatrix);
   {osov afinita podle y}
    Procedure AfY     (P:TPoint;var A:TMatrix);
   {stejnolehlost se stedem v potku}
    Procedure Homot   (Lambda:Double;var H:TMatrix);

   {**** nastaven matic slozench transformac **********}

   {nsoben matic}
    procedure Multip  (M,N:TMatrix;var Result:TMatrix);
   {osov afinita podle pmky PQ}
    Procedure GenAf   (P,Q,R:TPoint;var A:TMatrix);
   {stejnolehlost se stedem v bod S}
    Procedure GenHomot(S:TPoint;Lambda:Double;var H:TMatrix);
   {osov soumrnost podle pmky PQ}
    Procedure GenAxisSym(P,Q:TPoint;var O:TMatrix);
   {otoen o hel alfa kolem bodu S}
    Procedure GenRot(S:TPoint;Alfa:Double;var Mat:TMatrix);
   {stedov soumrnost se stedem v bod S}
    Procedure GenPointSym(S:TPoint;var Mat:TMatrix);
   {odvalen krunice (S,r) krokem h po vodorovn pmce}
    Procedure RollCircLine(S:TPoint;r,h:Double;var Mat:TMatrix);
   {odvalen krunice (S,r) krokem h po krunici (O,RO)}
    Procedure RollCircCirc(O:TPoint;R0:Double;S:TPoint;R:Double;
                                     h:Double;Into:Boolean;var M:TMatrix);
    {odvalen pmky po krunici (O,RO) krokem h, Alfa - hel prvodie}
    Procedure RollLineCirc(O:TPoint;R0:Double;StartAlfa,Alfa,h:Double;var Mat:TMatrix);
  end;

var  Draw2D: TDraw2D;

implementation

{$R *.DFM}

Procedure TDraw2D.InitImage(Width,Height:Integer);
begin
      Image1.Align:=alNone;
      Image1.Picture.Bitmap.PixelFormat:=pf24bit;
      Image1.Picture.Bitmap.Width:=Width;
      Image1.Picture.Bitmap.Height:=Height;
      Image1.Width:=Width;
      Image1.Height:=Height;
      Visible:=True;
end;

Procedure TDraw2D.ClearDigitalImage(Red,Green,Blue:Byte);
var i,j,Adr:Integer;
begin
  With Image1 do
  for j:=0 to Height-1 do
  begin
    PointOnScanRow:=Picture.Bitmap.ScanLine[j];
    for i:=0 to Width-1 do
    begin
      Adr:=3*i;
      PointOnScanRow[Adr]:=Blue;
      PointOnScanRow[succ(Adr)]:=Green;
      PointOnScanRow[succ(succ(Adr))]:=Red;
    end;
  end;
end;

Procedure TDraw2D.Scale(x1,x2,y1,y2:Double);
  begin
     Unit_X:= Image1.Width/(x2-x1);
     Unit_Y:= Image1.Height/(y2-y1);
     O[1]  := -x1*Unit_X;
     O[2]  :=  y2*Unit_Y;
  end;

function  TDraw2D.XCoor(x:Double):integer;
  begin
    XCoor:=Round(O[1]+Unit_X*x);
  end;

  function  TDraw2D.YCoor(y:Double):integer;
  begin
     YCoor:=Round(O[2]-Unit_Y*y);
  end;

  function  TDraw2D.InvXCoor(x:Integer):Double;
  begin
    InvXCoor:=(x-O[1])/Unit_X;
  end;

  function  TDraw2D.InvYCoor(y:Integer):Double;
  begin
     InvYCoor:=(O[2]-y)/Unit_Y;
  end;

  procedure TDraw2D.PutPixel(X:TPixel;Red,Green,Blue:Byte);
  var Adr:Integer;
  begin
      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[X[2]];
      Adr:=3*X[1];
      PointOnScanRow[Adr]:=Blue;
      PointOnScanRow[succ(Adr)]:=Green;
      PointOnScanRow[succ(succ(Adr))]:=Red;
  end;

  procedure TDraw2D.GetPixel(X:TPixel;var Red,Green,Blue:Byte);
  var Adr:Integer;
  begin
      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[X[2]];
      Adr:=3*X[1];
      Blue:=PointOnScanRow[Adr];
      Green:=PointOnScanRow[succ(Adr)];
      Red:=PointOnScanRow[succ(succ(Adr))];
  end;

  procedure TDraw2D.PutPoint(X:TPoint;Red,Green,Blue:Byte);
  var Pixel:TPixel;
  begin
    Pixel[1]:=XCoor(X[1]);Pixel[2]:=YCoor(X[2]);
    if (Pixel[1]>=0) and (Pixel[1]<Image1.Width) and
       (Pixel[2]>=0) and (Pixel[2]<Image1.Height) then
    PutPixel(Pixel,Red,Green,Blue);
  end;

  procedure TDraw2D.GetPoint(X:TPoint;var Red,Green,Blue:Byte);
  var Pixel:TPixel;
  begin
    Pixel[1]:=XCoor(X[1]);Pixel[2]:=YCoor(X[2]);
    GetPixel(Pixel,Red,Green,Blue);
  end;

  procedure TDraw2D.PixelLine(X,Y:TPixel;Red,Green,Blue:Byte);
  var p,p1,p2,Dx,Dy,i       :Integer;
      M                     :TPixel;
      Position              :Byte;
      Adr                   :Integer;
  Begin
  With Image1 do
  if (X[1]<0) or (X[1]>=Width) or (X[2]<0) or (X[2]>=Height) or
     (Y[1]<0) or (Y[1]>=Width) or (Y[2]<0) or (Y[2]>=Height) then exit;
  Dx:=Y[1]-X[1];
  if Dx<0 then
       begin
             p:=X[1];X[1]:=Y[1];Y[1]:=p;
             p:=X[2];X[2]:=Y[2];Y[2]:=p;
             Dx:=-Dx;
       end;
  Dy:=Y[2]-X[2];M[1]:=X[1];M[2]:=X[2];
  PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
  Adr:=3*M[1];
  PointOnScanRow[Adr]:=Blue;
  PointOnScanRow[succ(Adr)]:=Green;
  PointOnScanRow[succ(succ(Adr))]:=Red;
  if (Dx=0) and (Dy=0) then exit;                                {jedin bod}
  if Dx=0 then
           if Dy>0 then Position:=1                           {svisle nahoru}
                   else Position:=2                             {svisle dolu}
          else
           if Dy=0 then Position:=3                           {zleva doprava}
            else
            if Dy=Dx then Position:=4                                   {k=1}
                    else
                     if Dy=-Dx then Position:=5                        {k=-1}
                               else
                               if Dy>0 then
                                       if Dy>Dx then Position:=6        {k>1}
                                                else Position:=7      {0<k<1}
                                        else
                                         if -Dy>Dx then Position:=8    {k<-1}
                                                   else Position:=9; {-1<k<0}
Case Position of
  {svisle nahoru}
  1: begin
     Adr:=3*M[1];
     For i:=succ(X[2]) to Y[2] do
            begin
              PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[i];
              PointOnScanRow[Adr]:=Blue;
              PointOnScanRow[succ(Adr)]:=Green;
              PointOnScanRow[succ(succ(Adr))]:=Red;
            end;
     end;
  {svisle dol}
  2: begin
     Adr:=3*M[1];
     For i:=succ(Y[2]) to X[2] do
            begin
              PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[i];
              PointOnScanRow[Adr]:=Blue;
              PointOnScanRow[succ(Adr)]:=Green;
              PointOnScanRow[succ(succ(Adr))]:=Red;
            end;
     end;
   {zleva doprava}
   3:begin
      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
      For i:=succ(X[1]) to Y[1] do
      begin
       Adr:=3*i;
       PointOnScanRow[Adr]:=Blue;
       PointOnScanRow[succ(Adr)]:=Green;
       PointOnScanRow[succ(succ(Adr))]:=Red;
      end;
    end;
   {k=1}
   4:For i:=succ(X[1]) to Y[1] do
            begin
              inc(M[2]);
              PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
              Adr:=3*i;
              PointOnScanRow[Adr]:=Blue;
              PointOnScanRow[succ(Adr)]:=Green;
              PointOnScanRow[succ(succ(Adr))]:=Red;
            end;
   {k=-1}
   5:For i:=succ(X[1]) to Y[1] do
           begin
             dec(M[2]);
             PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
             Adr:=3*i;
             PointOnScanRow[Adr]:=Blue;
             PointOnScanRow[succ(Adr)]:=Green;
             PointOnScanRow[succ(succ(Adr))]:=Red;
           end;
   {k>1}
   6:begin
       p:=Dx;Dx:=Dy;Dy:=p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]<Y[2] do
       begin
        Inc(M[2]);
        if p>0 then begin
                       Inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
        Adr:=3*M[1];
        PointOnScanRow[Adr]:=Blue;
        PointOnScanRow[succ(Adr)]:=Green;
        PointOnScanRow[succ(succ(Adr))]:=Red;
      end;
     end;
  {0<k<1}
  7: begin
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
       While M[1]<Y[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      inc(M[2]);p:=p+p2;
                      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        Adr:=3*M[1];
        PointOnScanRow[Adr]:=Blue;
        PointOnScanRow[succ(Adr)]:=Green;
        PointOnScanRow[succ(succ(Adr))]:=Red;
       end;
      end;
  {k<-1}
  8: begin
       p:=Dx;Dx:=Dy;Dy:=-p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]>Y[2] do
       begin
        dec(M[2]);
        if p<0 then begin
                     inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
        Adr:=3*M[1];
        PointOnScanRow[Adr]:=Blue;
        PointOnScanRow[succ(Adr)]:=Green;
        PointOnScanRow[succ(succ(Adr))]:=Red;
      end;
     end;
  {-1<k<0}
  9: begin
       Dy:=-Dy;PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[1]<Y[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      dec(M[2]);
                      p:=p+p2;
                      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        Adr:=3*M[1];
        PointOnScanRow[Adr]:=Blue;
        PointOnScanRow[succ(Adr)]:=Green;
        PointOnScanRow[succ(succ(Adr))]:=Red;
      end;
     end;
  end;
end;

procedure TDraw2D.PixelInterpolLine(X,Y:TPixel;RedX,GreenX,BlueX,
                                              RedY,GreenY,BlueY:Byte);
  var p,p1,p2,Dx,Dy,i       :Integer;
      M                     :TPixel;
      Position              :Byte;
      Adr                   :Integer;
      StepR,StepG,StepB,R,G,B:Single;
  Begin
  With Image1 do
  if (X[1]<0) or (X[1]>=Width) or (X[2]<0) or (X[2]>=Height) or
     (Y[1]<0) or (Y[1]>=Width) or (Y[2]<0) or (Y[2]>=Height) then exit;
  Dx:=Y[1]-X[1];
  if Dx<0 then
       begin
             p:=X[1];X[1]:=Y[1];Y[1]:=p;
             p:=X[2];X[2]:=Y[2];Y[2]:=p;
             Dx:=-Dx;
             Position:=RedX;  RedX:=RedY;    RedY:=Position;
             Position:=GreenX;GreenX:=GreenY;GreenY:=Position;
             Position:=BlueX; BlueX:=BlueY;  BlueY:=Position;
       end;
  Dy:=Y[2]-X[2];M[1]:=X[1];M[2]:=X[2];
  PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
  Adr:=3*M[1];
  PointOnScanRow[Adr]:=BlueX;
  PointOnScanRow[succ(Adr)]:=GreenX;
  PointOnScanRow[succ(succ(Adr))]:=RedX;
  if (Dx=0) and (Dy=0) then exit;                                {jedin bod}
  if abs(Dx)>abs(Dy) then begin
                 StepR:=(RedY-RedX)/Abs(DX);
                 StepG:=(GreenY-GreenX)/Abs(DX);
                 StepB:=(BlueY-BlueX)/Abs(DX);
                end
           else begin
                 StepR:=(RedY-RedX)/Abs(DY);
                 StepG:=(GreenY-GreenX)/Abs(DY);
                 StepB:=(BlueY-BlueX)/Abs(DY);
                end;
  if Dx=0 then
           if Dy>0 then Position:=1                           {svisle nahoru}
                   else Position:=2                             {svisle dolu}
          else
           if Dy=0 then Position:=3                           {zleva doprava}
            else
            if Dy=Dx then Position:=4                                   {k=1}
                    else
                     if Dy=-Dx then Position:=5                        {k=-1}
                               else
                               if Dy>0 then
                                       if Dy>Dx then Position:=6        {k>1}
                                                else Position:=7      {0<k<1}
                                        else
                                         if -Dy>Dx then Position:=8    {k<-1}
                                                   else Position:=9; {-1<k<0}
Case Position of
  {svisle nahoru}
  1: begin
     Adr:=3*M[1];R:=RedX;G:=GreenX;B:=BlueX;
     For i:=succ(X[2]) to Y[2] do
            begin
              R:=R+StepR;G:=G+StepG;B:=B+StepB;
              PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[i];
              PointOnScanRow[Adr]:=Round(B);
              PointOnScanRow[succ(Adr)]:=Round(G);
              PointOnScanRow[succ(succ(Adr))]:=Round(R);
            end;
     end;
  {svisle dol}
  2: begin
     Adr:=3*M[1];R:=RedY;G:=GreenY;B:=BlueY;
     For i:=succ(Y[2]) to X[2] do
            begin
              R:=R+StepR;G:=G+StepG;B:=B+StepB;
              PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[i];
              PointOnScanRow[Adr]:=Round(B);
              PointOnScanRow[succ(Adr)]:=Round(G);
              PointOnScanRow[succ(succ(Adr))]:=Round(R);
            end;
     end;
   {zleva doprava}
   3:begin
      R:=RedX;G:=GreenX;B:=BlueX;
      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
      For i:=succ(X[1]) to Y[1] do
      begin
       R:=R+StepR;G:=G+StepG;B:=B+StepB;
       Adr:=3*i;
       PointOnScanRow[Adr]:=Round(B);
       PointOnScanRow[succ(Adr)]:=Round(G);
       PointOnScanRow[succ(succ(Adr))]:=Round(R);
      end;
    end;
   {k=1}
   4:begin
     R:=RedX;G:=GreenX;B:=BlueX;
     For i:=succ(X[1]) to Y[1] do
            begin
              inc(M[2]);
              R:=R+StepR;G:=G+StepG;B:=B+StepB;
              PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
              Adr:=3*i;
              PointOnScanRow[Adr]:=Round(B);
              PointOnScanRow[succ(Adr)]:=Round(G);
              PointOnScanRow[succ(succ(Adr))]:=Round(R);
            end;
     end;
   {k=-1}
   5: begin
      R:=RedX;G:=GreenX;B:=BlueX;
      For i:=succ(X[1]) to Y[1] do
           begin
             dec(M[2]);
             R:=R+StepR;G:=G+StepG;B:=B+StepB;
             PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
             Adr:=3*i;
             PointOnScanRow[Adr]:=Round(B);
             PointOnScanRow[succ(Adr)]:=Round(G);
             PointOnScanRow[succ(succ(Adr))]:=Round(R);
           end;
      end;
   {k>1}
   6:begin
       R:=RedX;G:=GreenX;B:=BlueX;
       p:=Dx;Dx:=Dy;Dy:=p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]<Y[2] do
       begin
        Inc(M[2]);
        if p>0 then begin
                       Inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
        Adr:=3*M[1];
        R:=R+StepR;G:=G+StepG;B:=B+StepB;
        PointOnScanRow[Adr]:=Round(B);
        PointOnScanRow[succ(Adr)]:=Round(G);
        PointOnScanRow[succ(succ(Adr))]:=Round(R);
      end;
     end;
  {0<k<1}
  7: begin
       R:=RedX;G:=GreenX;B:=BlueX;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
       While M[1]<Y[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      inc(M[2]);p:=p+p2;
                      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        Adr:=3*M[1];
        R:=R+StepR;G:=G+StepG;B:=B+StepB;
        PointOnScanRow[Adr]:=Round(B);
        PointOnScanRow[succ(Adr)]:=Round(G);
        PointOnScanRow[succ(succ(Adr))]:=Round(R);
       end;
      end;
  {k<-1}
  8: begin
       R:=RedX;G:=GreenX;B:=BlueX;
       p:=Dx;Dx:=Dy;Dy:=-p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]>Y[2] do
       begin
        dec(M[2]);
        if p<0 then begin
                     inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
        Adr:=3*M[1];
        R:=R+StepR;G:=G+StepG;B:=B+StepB;
        PointOnScanRow[Adr]:=Round(B);
        PointOnScanRow[succ(Adr)]:=Round(G);
        PointOnScanRow[succ(succ(Adr))]:=Round(R);
      end;
     end;
  {-1<k<0}
  9: begin
       R:=RedX;G:=GreenX;B:=BlueX;
       Dy:=-Dy;PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[1]<Y[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      dec(M[2]);
                      p:=p+p2;
                      PointOnScanRow:=Image1.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        Adr:=3*M[1];
        R:=R+StepR;G:=G+StepG;B:=B+StepB;
        PointOnScanRow[Adr]:=Round(B);
        PointOnScanRow[succ(Adr)]:=Round(G);
        PointOnScanRow[succ(succ(Adr))]:=Round(R);
      end;
     end;
  end;
end;

Procedure TDraw2D.Cross(X:TPoint;Size,Red,Green,Blue:Byte);
var Pixel,A,B,C,D:TPixel;
begin
   Pixel[1]:=XCoor(X[1]);Pixel[2]:=YCoor(X[2]);
    if (Pixel[1]>=Size) and (Pixel[1]<Image1.Width-Size) and
       (Pixel[2]>=Size) and (Pixel[2]<Image1.Height-Size) then
   begin
   A[1]:=Pixel[1]-Size;A[2]:=Pixel[2];
   B[1]:=Pixel[1]+Size;B[2]:=Pixel[2];
   C[1]:=Pixel[1];  C[2]:=Pixel[2]-Size;
   D[1]:=Pixel[1];  D[2]:=Pixel[2]+Size;
   PixelLine(A,B,Red,Green,Blue);
   PixelLine(C,D,Red,Green,Blue);
   end;
end;

 procedure TDraw2D.Line(X,Y:TPoint;Red,Green,Blue:Byte);
  var A,B  :TPixel;
  begin
     A[1]:=XCoor(X[1]);A[2]:=YCoor(X[2]);
     B[1]:=XCoor(Y[1]);B[2]:=YCoor(Y[2]);
     PixelLine(A,B,Red,Green,Blue);
  end;

 procedure TDraw2D.PointInterpolLine(X,Y:TPoint;RedX,GreenX,BlueX,
                                                RedY,GreenY,BlueY:byte);
  var A,B  :TPixel;
  begin
     A[1]:=XCoor(X[1]);A[2]:=YCoor(X[2]);
     B[1]:=XCoor(Y[1]);B[2]:=YCoor(Y[2]);
     PixelInterpolLine(A,B,RedX,GreenX,BlueX,RedY,GreenY,BlueY);
  end;

 Procedure TDraw2D.XAxis(x1,x2,y:Double;Red,Green,Blue:Byte);
 var A,B:TPoint;
 begin
    A[1]:=x1;A[2]:=y;B[1]:=x2;B[2]:=A[2];
    cvLine(A,B,Red,Green,Blue);
  end;

Procedure TDraw2D.YAxis(y1,y2,x:Double;Red,Green,Blue:Byte);
var A,B:TPoint;
  begin
    A[1]:=x;A[2]:=y1;B[1]:=A[1];B[2]:=y2;
    cvLine(A,B,Red,Green,Blue);
  end;

procedure TDraw2D.GaugedXAxis(x1,x2,y:Double;Red,Green,Blue:Byte);
  var  AxisUnit        :Double;
       Text            :String;
       Lx,Exponent     :Integer;

   begin
   XAxis(x1,x2,y,Red,Green,Blue);
   Image1.Canvas.Font.Color:=Red+256*Green+256*256*Blue;
   Image1.Canvas.Pen.Color:=Red+256*Green+256*256*Blue;
   AxisUnit:=1E30;Lx:=0;Exponent:=30;
   While (x2-x1)/AxisUnit<3 do
    begin
       AxisUnit:=AxisUnit/10;Exponent:=Exponent-1;
    end;
   Lx:=0;
   if x1<0 then
     Repeat Lx:=Lx-1 Until AxisUnit*(Lx-1)<x1
           else
     Repeat Lx:=Lx+1 Until AxisUnit*(Lx+1)>x1;
   With Image1.Canvas do
   repeat
      MoveTo(XCoor(AxisUnit*Lx),YCoor(y)-3);
      LineTo(XCoor(AxisUnit*Lx),YCoor(y)+3);
      Str(Lx,Text);
      TextOut(XCoor(AxisUnit*Lx)+3,YCoor(y)+5,Text);
      Lx:=Lx+1;
   until AxisUnit*(Lx+1)>x2;
   Str(Exponent,Text);
   Image1.Canvas.TextOut(XCoor(x2)-40,YCoor(y)+5,'*10');
   Image1.Canvas.TextOut(XCoor(x2)-20,YCoor(Y)+1,Text);
   end;

procedure TDraw2D.GaugedYAxis(y1,y2,x:Double;Red,Green,Blue:Byte);
   var AxisUnit        :Double;
       Text            :String;
       Ly,Exponent     :Integer;
   begin
   YAxis(y1,y2,x,Red,Green,Blue);
   Image1.Canvas.Font.Color:=Red+256*Green+256*256*Blue;
   Image1.Canvas.Pen.Color:=Red+256*Green+256*256*Blue;
   AxisUnit:=1E30;Ly:=0;Exponent:=30;
   While (y2-y1)/AxisUnit<3 do
    begin
       AxisUnit:=AxisUnit/10;Exponent:=Exponent-1;
    end;
   Ly:=0;
   if y1<0 then
     Repeat Ly:=Ly-1 Until AxisUnit*(Ly-1)<y1
           else
     Repeat Ly:=Ly+1 Until AxisUnit*(Ly+1)>y1;
   With Image1.Canvas do
   repeat
      MoveTo(XCoor(x)-3,YCoor(AxisUnit*Ly));
      LineTo(XCoor(x)+3,YCoor(AxisUnit*Ly));
      Str(Ly,Text);
      TextOut(XCoor(x)-25,YCoor(AxisUnit*Ly)-15,Text);
      Ly:=Ly+1;
   until AxisUnit*(Ly+1)>y2;
   Str(Exponent,Text);
   Image1.Canvas.TextOut(XCoor(x)+5,YCoor(y2)+10,'    ');
   Image1.Canvas.TextOut(XCoor(x)+5,YCoor(y2)+10,'*10');
   Image1.Canvas.TextOut(XCoor(x)+25,YCoor(y2)+3,Text);
   end;

 procedure TDraw2D.PolyLine(X:TArrayOfPoints;n:Word;Red,Green,Blue:Byte);
 var i:Word;
     A,B:TPixel;
 begin
   A[1]:=XCoor(X[0,1]);A[2]:=YCoor(X[0,2]);
   for i:=1 to n-1 do
   begin
     B[1]:=XCoor(X[i,1]);B[2]:=YCoor(X[i,2]);
    if (A[1]>=0) and (A[1]<Image1.Width) and
       (A[2]>=0) and (A[2]<Image1.Height) and
       (B[1]>=0) and (B[1]<Image1.Width) and
       (B[2]>=0) and (B[2]<Image1.Height) then
            PixelLine(A,B,Red,Green,Blue);
    A:=B;
   end;
 end;

 Procedure TDraw2D.Triangle(A,B,C:TPoint;Red,Green,Blue:Byte);
 begin
   Line(A,B,Red,Green,Blue);
   Line(B,C,Red,Green,Blue);
   Line(C,A,Red,Green,Blue);
 end;

 procedure TDraw2D.Quadrangle(A,B,C,D:TPoint;Red,Green,Blue:byte);
 begin
     Line(A,B,Red,Green,Blue);
     Line(B,C,Red,Green,Blue);
     Line(C,D,Red,Green,Blue);
     Line(D,A,Red,Green,Blue);
 end;

Procedure TDraw2D.ClearImage(Red,Green,Blue:byte);
begin
  With Image1 do
  begin
    Canvas.Pen.Color:=Red+256*Green+256*256*Blue;
    Canvas.Brush.Color:=Red+256*Green+256*256*Blue;
    Canvas.Rectangle(0,0,Width,Height);
  end;
end;

procedure TDraw2D.cvLine(X,Y:TPoint;Red,Green,Blue:byte);
begin
     With Image1.Canvas do
     begin
       Pen.Color:=Red+256*Green+256*256*Blue;
       MoveTo(XCoor(X[1]),YCoor(X[2]));
       LineTo(XCoor(Y[1]),YCoor(Y[2]));
     end;
end;

procedure TDraw2D.cvPolyLine(X:TArrayOfPoints;n:Word;Red,Green,Blue:byte);
var i:Word;
begin
    With Image1.Canvas do
     begin
       Pen.Color:=Red+256*Green+256*256*Blue;
       MoveTo(XCoor(X[0,1]),YCoor(X[0,2]));
       for i:=1 to n-1 do
                LineTo(XCoor(X[i,1]),YCoor(X[i,2]));
    end;
end;

Procedure TDraw2D.cvTriangle(A,B,C:TPoint;Red,Green,Blue:Byte);
begin
   cvLine(A,B,Red,Green,Blue);
   cvLine(B,C,Red,Green,Blue);
   cvLine(C,A,Red,Green,Blue);
end;

 procedure TDraw2D.cvQuadrangle(A,B,C,D:TPoint;Red,Green,Blue:byte);
 begin
     cvLine(A,B,Red,Green,Blue);
     cvLine(B,C,Red,Green,Blue);
     cvLine(C,D,Red,Green,Blue);
     cvLine(D,A,Red,Green,Blue);
 end;


procedure TDraw2D.cvCircle(S:TPoint;r:Double;Red,Green,Blue:byte);
   var x1,x2,y1,y2:Integer;
   begin
     x1:=XCoor(S[1]+r);y1:=YCoor(S[2]+r);
     x2:=XCoor(S[1]-r);y2:=YCoor(S[2]-r);
     With Image1.Canvas do
     begin
       Pen.Color:=Red+256*Green+256*256*Blue;
       Ellipse(x1,y1,x2,y2);
     end;
   end;

  procedure TDraw2D.TransOfPoint(X:TPoint;Z:TMatrix;var Xc:TPoint);
   var i,j:Byte;
   begin
      for i:=1 to 3 do Xc[i]:=0;
      for j:=1 to 3 do
       for i:=1 to 3 do
           Xc[j]:=Xc[j]+X[i]*Z[i,j];
   end;

   Procedure TDraw2D.TransOfTriangle(A,B,C:TPoint;Z:TMatrix;
                 var Ac,Bc,Cc:TPoint);
   begin
      TransOfPoint(A,Z,Ac);
      TransOfPoint(B,Z,Bc);
      TransOfPoint(C,Z,Cc);
   end;

{***************************************}
{********** Translace   ****************}
{***************************************}

Procedure TDraw2D.Transl(V:TVector;var T:TMatrix);
begin
    T[1,1]:=1;   T[1,2]:=0;   T[1,3]:=0;
    T[2,1]:=0;   T[2,2]:=1;   T[2,3]:=0;
    T[3,1]:=v[1];T[3,2]:=v[2];T[3,3]:=1;
end;

{***************************************}
{**** Rotace kolem pocatku *************}
{***************************************}

Procedure TDraw2D.Rot(Alfa:Double;Var R:TMatrix);
begin
    R[1,1]:= cos(Alfa); R[1,2]:= sin(Alfa);  R[1,3]:=0;
    R[2,1]:= -sin(Alfa);R[2,2]:= cos(Alfa);  R[2,3]:=0;
    R[3,1]:= 0;         R[3,2]:= 0;          R[3,3]:=1;
end;

{***************************************}
{**** Stred.symetrie podle pocatku *****}
{***************************************}

Procedure TDraw2D.OrigSym(var S:TMatrix);
begin
    S[1,1]:=-1; S[1,2]:= 0;  S[1,3]:=0;
    S[2,1]:= 0; S[2,2]:=-1;  S[2,3]:=0;
    S[3,1]:= 0; S[3,2]:= 0;  S[3,3]:=1;
end;

{***************************************}
{**** Osova symetrie podle osy x *******}
{***************************************}

Procedure TDraw2D.AxisSymX(var O:TMatrix);
begin
    O[1,1]:= 1; O[1,2]:= 0;  O[1,3]:=0;
    O[2,1]:= 0; O[2,2]:=-1;  O[2,3]:=0;
    O[3,1]:= 0; O[3,2]:= 0;  O[3,3]:=1;
end;

{***************************************}
{**** Osova symetrie podle osy y *******}
{***************************************}

Procedure TDraw2D.AxisSymY(var O:TMatrix);
begin
    O[1,1]:=-1; O[1,2]:= 0;  O[1,3]:=0;
    O[2,1]:= 0; O[2,2]:= 1;  O[2,3]:=0;
    O[3,1]:= 0; O[3,2]:= 0;  O[3,3]:=1;
end;

{***************************************}
{**** Osova afinita podle x ************}
{***************************************}

Procedure TDraw2D.AfX(P:TPoint;var A:TMatrix);
begin
    A[1,1]:= 1;    A[1,2]:= 0   ;  A[1,3]:=0;
    A[2,1]:= P[1]; A[2,2]:= P[2];  A[2,3]:=0;
    A[3,1]:= 0;    A[3,2]:= 0   ;  A[3,3]:=1;
end;


{***************************************}
{**** Osova afinita podle y ************}
{***************************************}

Procedure TDraw2D.AfY(P:TPoint;var A:TMatrix);
begin
    A[1,1]:= P[1]; A[1,2]:= P[2];  A[1,3]:=0;
    A[2,1]:= 0   ; A[2,2]:= 1   ;  A[2,3]:=0;
    A[3,1]:= 0   ; A[3,2]:= 0   ;  A[3,3]:=1;
end;

{**********************************************}
{**** Stejnolehlost se stredem v pocatku ******}
{**********************************************}

Procedure TDraw2D.Homot(lambda:Double;var H:TMatrix);
begin
    H[1,1]:= lambda; H[1,2]:= 0     ; H[1,3]:=0;
    H[2,1]:= 0     ; H[2,2]:= lambda; H[2,3]:=0;
    H[3,1]:= 0     ; H[3,2]:= 0     ; H[3,3]:=1;
end;

{**********************************************}
{**** Skladani transformaci  ******************}
{**********************************************}

{**********************************************}
{**** Souci matic            ******************}
{**********************************************}

Procedure TDraw2D.Multip(M,N:TMatrix;var Result:TMatrix);
Var i,j,k:Integer;
begin
    for i:=1 to 3 do for j:=1 to 3 do Result[i,j]:=0;
    for i:=1 to 3 do for k:=1 to 3 do for j:=1 to 3 do
                      Result[i,j]:=Result[i,j]+M[i,k]*N[k,j];
end;

{**********************************************}
{**** Afinita s obecnou osou    ***************}
{**********************************************}


Procedure TDraw2D.GenAf(P,Q,R:TPoint;var A:TMatrix);
var V    :TVector;
    Alfa :Double;
    Mat1,Mat2:TMatrix;
begin
  V[1]     := -P[1];V[2]:= -P[2];
  Alfa     := ArcTan((Q[2]-P[2])/(Q[1]-P[1]));
  Transl(V,Mat1); Rot(-Alfa,Mat2); Multip(Mat1,Mat2,A);
  Mat1:=A;        AfX(R,Mat2);     Multip(Mat1,Mat2,A);
  Mat1:=A;        Rot(Alfa,Mat2);  Multip(Mat1,Mat2,A);
  V[1]:=-V[1];V[2]:=-V[2];
  Mat1:=A;        Transl(V,Mat2);  Multip(Mat1,Mat2,A);
  Mat1:=A;        Transl(V,Mat2);  Multip(Mat1,Mat2,A);
end;

{**********************************************}
{**** Stejnolehlost s obecnou osou  ***********}
{**********************************************}

Procedure TDraw2D.GenHomot(S:TPoint;Lambda:Double;var H:TMatrix);
var Mat1,Mat2           :TMatrix;
    V                   :TVector;
    i                   :Integer;
begin
   V[1]:=-S[1];V[2]:=-S[2];
   Transl    (V,Mat1);
   Homot    (Lambda,Mat2);
   Multip   (Mat1,Mat2,H);
   V[1]:=-V[1];V[2]:=-V[2];Mat1:=H;
   Transl    (V,Mat2);
   Multip   (Mat1,Mat2,H);
end;

{**********************************************}
{**** soumernost s obecnou osou  **************}
{**********************************************}

Procedure TDraw2D.GenAxisSym(P,Q:TPoint;var O:TMatrix);
var V    :TVector;
    Alfa :Double;
    Mat1,Mat2:TMatrix;
begin
  V[1]     := -P[1];V[2]:= -P[2];
  Alfa     := ArcTan((Q[2]-P[2])/(Q[1]-P[1]));
  Transl(V,Mat1); Rot(-Alfa,Mat2);Multip(Mat1,Mat2,O);
  Mat1:=O;       AxisSymX(Mat2); Multip(Mat1,Mat2,O);
  Mat1:=O;       Rot(Alfa,Mat2); Multip(Mat1,Mat2,O);
  V[1]:=-V[1];V[2]:=-V[2];
  Mat1:=O;       Transl(V,Mat2);  Multip(Mat1,Mat2,O);
end;

{**********************************************}
{**** Rotace kolem obecneho bodu  *************}
{**********************************************}

Procedure TDraw2D.GenRot(S:TPoint;Alfa:Double;var Mat:TMatrix);
var Mat1,Mat2           :TMatrix;
    V                   :TVector;
    i                   :Integer;
begin
   V[1]:=-S[1];V[2]:=-S[2];
   Transl    (V,Mat1);
   Rot      (Alfa,Mat2);
   Multip   (Mat1,Mat2,Mat);
   V[1]:=-V[1];V[2]:=-V[2];Mat1:=Mat;
   Transl    (V,Mat2);
   Multip   (Mat1,Mat2,Mat);
end;

{**********************************************}
{**** Soumernost podle obecneho bodu  *********}
{**********************************************}

Procedure TDraw2D.GenPointSym(S:TPoint;var Mat:TMatrix);
begin
   GenRot(S,pi,Mat);
end;

{**********************************************}
{**** Valeni kruznice po primce  **************}
{**********************************************}

Procedure TDraw2D.RollCircLine(S:TPoint;r,h:Double;var Mat:TMatrix);
var V    :TVector;
    T1,T2:TMatrix;

begin
 v[1]:=h;v[2]:=0;v[3]:=1;
 GenRot(S,-h/r,T1);
 Transl(V,T2);
 Multip(T1,T2,Mat);
end;

Procedure TDraw2D.RollCircCirc(O:TPoint;R0:Double;S:TPoint;R:Double;
                                    h:Double;Into:Boolean;var M:TMatrix);
var T1,T2:TMatrix;
    Sc   :TPoint;
begin
 GenRot(O,h/R0,T1);
 TransOfPoint(S,T1,Sc);
 if Into then GenRot(Sc,-h/r,T2) else GenRot(Sc,h/r,T2);
 Multip(T1,T2,M);
end;

Procedure TDraw2D.RollLineCirc(O:TPoint;R0:Double;StartAlfa,Alfa,h:Double;var Mat:TMatrix);
var T1,T2:TMatrix;
    v    :TVector;
    hAlfa:Double;
begin
 v[1]:=h*Cos(pi/2-Alfa-StartAlfa);v[2]:=-h*sin(pi/2-Alfa-StartAlfa);
 Transl(v,T1);
 GenRot(O,h/R0,T2);
 Multip(T1,T2,Mat);
end;

end.
